﻿using System;
using SpriteKit;
using CoreGraphics;
using UIKit;

namespace Color
{
	public class Block : SKSpriteNode
	{
		GameScene _scene;
		double _vx = 0;
		double _vy = 0;
		public bool _visible = false;

		public Block(GameScene scene,string name, Random rnd)
		{
			_scene = scene;
			var sprite = SKSpriteNode.FromImageNamed(name);
			Add(sprite);
			Name = name;
			var w = sprite.Size.Width;
			var h = sprite.Size.Height;
			Position = new CGPoint(
				w+(rnd.NextDouble() * (scene.Size.Width-2*w)),
				h+(rnd.NextDouble() * (scene.Size.Height-2*h)));
			_vx = 0.1 - rnd.NextDouble()*0.2;
			_vy = 0.1 - rnd.NextDouble()*0.2;
			UserInteractionEnabled = true;
			scene.AddChild(this);
			_visible = true;
		}

		public bool Move()
		{
			if (!_visible) return false;

			Position = new CGPoint(Position.X + _vx, Position.Y + _vy);

			if (Position.X < -20 || Position.X > _scene.Size.Width+20
	 	  	||  Position.Y < 20 || Position.Y > _scene.Size.Height+60 )
			{
				RemoveFromParent();
				_visible = false;
			} 

			return _visible;
		}

		public override void TouchesEnded(Foundation.NSSet touches, UIKit.UIEvent evt)
		{
			base.TouchesEnded(touches, evt);
			int r = (Name == "Red"  ) ? 1 : 0;
			int g = (Name == "Green") ? 1 : 0;
			int b = (Name == "Blue" ) ? 1 : 0;
			_scene.SetBackgroundColor(r,g,b);
			RemoveFromParent();
			_visible = false;
			_scene._mixSound.Stop();
			_scene._mixSound.CurrentTime = 0;
			_scene._mixSound.Play();
		}
	}
}
